%define upstream_name    threads
%define upstream_version 2.21

%{?perl_default_filter}

Name:       perl-%{upstream_name}
Version:    %perl_convert_version 2.40
Release:    %mkrel 2

Summary:    Perl interpreter-based threads
License:    GPL+ or Artistic
Group:      Development/Perl
Url:        https://metacpan.org/release/%{upstream_name}
Source0:    https://cpan.metacpan.org/authors/id/J/JD/JDHEDDEN/%{upstream_name}-%{upstream_version}.tar.gz
# Unbundled from perl 5.40.0-RC1
Patch0:         threads-2.21-Upgrade-to-2.40.patch

BuildRequires: perl(Carp)
BuildRequires: perl(Config)
BuildRequires: perl(Devel::PPPort)
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(ExtUtils::testlib)
BuildRequires: perl(Hash::Util)
BuildRequires: perl(IO::File)
BuildRequires: perl(Test::More)
BuildRequires: perl(XSLoader)
BuildRequires: perl(overload)
BuildRequires: perl(strict)
BuildRequires: perl(warnings)
BuildRequires: perl-devel
%description
Perl 5.6 introduced something called interpreter threads. Interpreter
threads are different from _5005threads_ (the thread model of Perl 5.005)
by creating a new Perl interpreter per thread, and not sharing any data or
state between threads by default.

Prior to Perl 5.8, this has only been available to people embedding Perl,
and for emulating fork() on Windows.

The _threads_ API is loosely based on the old Thread.pm API. It is very
important to note that variables are not shared between threads, all
variables are by default thread local. To use shared variables one must
also use the threads::shared manpage:

%prep
%autosetup -p1 -n %{upstream_name}-%{upstream_version}
# Generate ppport.h
perl -MDevel::PPPort \
    -e "Devel::PPPort::WriteFile() or die 'Could not generate ppport.h: $!'"


%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%make_build

%check
make test

%install
%make_install

%files
%doc Changes META.json META.yml MYMETA.yml README examples
%{_mandir}/man3/*
%perl_vendorarch/*


%changelog
* Sun Jun 29 2025 umeabot <umeabot> 2.400.0-2.mga10
+ Revision: 2226457
- Mageia 10 Mass Rebuild

* Fri Aug 23 2024 tv <tv> 2.400.0-1.mga10
+ Revision: 2088892
- Upgrade to 2.40 as provided in perl-5.40.0-RC1
+ neoclust <neoclust>
- Rebuild against new perl

* Fri Dec 01 2023 tv <tv> 2.160.0-13.mga10
+ Revision: 2012464
- Really rebuild for perl-5.38

* Tue Nov 28 2023 tv <tv> 2.160.0-12.mga10
+ Revision: 2010912
- Rebuild for perl-5.38
- Rebuild for perl-5.38

* Tue Jun 07 2022 umeabot <umeabot> 2.160.0-10.mga9
+ Revision: 1862512
- Rebuild for Perl 5.36

* Thu Mar 17 2022 umeabot <umeabot> 2.160.0-9.mga9
+ Revision: 1796132
- Mageia 9 Mass Rebuild

* Mon May 24 2021 umeabot <umeabot> 2.160.0-8.mga9
+ Revision: 1727154
- Rebuild for perl 5.34

* Wed Jun 17 2020 umeabot <umeabot> 2.160.0-7.mga8
+ Revision: 1594776
- Rebuild for perl 5.32

* Sun Feb 16 2020 umeabot <umeabot> 2.160.0-6.mga8
+ Revision: 1530130
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%makeinstall_std

* Tue Aug 27 2019 tmb <tmb> 2.160.0-5.mga8
+ Revision: 1433923
- rebuild for perl 5.30

* Fri Sep 21 2018 umeabot <umeabot> 2.160.0-4.mga7
+ Revision: 1294088
- Mageia 7 Mass Rebuild

* Wed Aug 08 2018 pterjan <pterjan> 2.160.0-3.mga7
+ Revision: 1249959
- Rebuild for perl 5.28

* Tue Oct 03 2017 tv <tv> 2.160.0-2.mga7
+ Revision: 1167104
- rebuild with fixed rpm for missing autodeps

* Tue Sep 19 2017 tv <tv> 2.160.0-1.mga7
+ Revision: 1155923
- update to 2.16

* Thu Aug 31 2017 pterjan <pterjan> 2.20.0-6.mga7
+ Revision: 1149336
- Rebuild for perl ABI changes

* Sat Jul 22 2017 neoclust <neoclust> 2.20.0-5.mga7
+ Revision: 1127354
- Rebuild against new Perl 5.26

* Sun Jun 19 2016 pterjan <pterjan> 2.20.0-4.mga6
+ Revision: 1035189
- Rebuild for perl 5.22.2

* Fri Feb 12 2016 umeabot <umeabot> 2.20.0-3.mga6
+ Revision: 958124
- Mageia 6 Mass Rebuild

* Fri Jun 26 2015 tv <tv> 2.20.0-2.mga6
+ Revision: 845360
- rebuild for soname-ifed perl

* Tue Jun 23 2015 sander85 <sander85> 2.20.0-1.mga6
+ Revision: 841417
- update to 2.02

* Mon Feb 16 2015 shlomif <shlomif> 1.960.0-1.mga5
+ Revision: 815114
- New perl-threads needed by slic3r-experimental.
  Reading from my apprentice:
  This is just a version bump required to silence a warning in
  slic3r-experimental.  Nothing else seems to have this package as a
  dependency, as the same 1.92 version was shipped in perl core.  While 1.92
  seems to work in testing, we haven't been able to determine the underlying
  reason for the explicit requirement against 1.96+.

* Sun Oct 19 2014 umeabot <umeabot> 1.920.0-5.mga5
+ Revision: 790006
- Rebuild to potentially add missing dependencies

* Wed Oct 15 2014 umeabot <umeabot> 1.920.0-4.mga5
+ Revision: 745151
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.920.0-3.mga5
+ Revision: 687063
- Mageia 5 Mass Rebuild

* Tue Jun 03 2014 pterjan <pterjan> 1.920.0-2.mga5
+ Revision: 631940
- Rebuild for perl 5.20

* Mon Feb 10 2014 jquelin <jquelin> 1.920.0-1.mga5
+ Revision: 588848
- update to 1.92

* Sat Oct 19 2013 umeabot <umeabot> 1.870.0-2.mga4
+ Revision: 525998
- Mageia 4 Mass Rebuild

* Sun Jun 02 2013 kharec <kharec> 1.870.0-1.mga4
+ Revision: 435153
- update to 1.87

* Wed May 29 2013 jquelin <jquelin> 1.860.0-4.mga4
+ Revision: 431905
- perl 5.18.0 rebuild

* Sun Jan 13 2013 umeabot <umeabot> 1.860.0-3.mga3
+ Revision: 375573
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed May 30 2012 jquelin <jquelin> 1.860.0-2.mga3
+ Revision: 251246
- rebuild for perl 5.16

* Thu Dec 15 2011 jquelin <jquelin> 1.860.0-1.mga2
+ Revision: 181841
- update to 1.86

* Fri Nov 04 2011 jquelin <jquelin> 1.850.0-2.mga2
+ Revision: 162846
- take priority over module bundled with perl 5.14.2

* Mon Sep 26 2011 jquelin <jquelin> 1.850.0-1.mga2
+ Revision: 148306
- update to 1.85

* Wed Jun 15 2011 jquelin <jquelin> 1.830.0-1.mga2
+ Revision: 107627
- update to 1.83

* Sat Jun 11 2011 spuhler <spuhler> 1.820.0-2.mga2
+ Revision: 103675
- increase rel for rebuild

* Sat Feb 26 2011 jquelin <jquelin> 1.820.0-1.mga1
+ Revision: 60636
- update to 1.82

* Tue Jan 18 2011 jquelin <jquelin> 1.810.0-1.mga1
+ Revision: 22983
- cleaning spec file
- imported package perl-threads

